@echo off
REM Take out at-sign for DOS versions less than 3.3
REM ******* Need to have SHOWEXIT.BAT in the path, or replace SHOWEXIT 
REM         commands with GOTO END *********

REM Next lines look for some potential help requests
if %1x==x goto MENU
if %1==? goto MENU
if %1==/? goto MENU
if %1==-? goto MENU

REM Next lines use the DOS command FOR to identify the argument and jump point
for %%f in (help files dir commands command cmd dos where here file space) do if %1==%%f goto %%f
for %%f in (HELP FILES DIR COMMANDS COMMAND CMD DOS WHERE HERE FILE SPACE) do if %1==%%f goto %%f

REM If argument not identified, go to the error handler at GOOF
goto GOOF

REM This section does a DIR, with a PAUSE automatically inserted for new users
:DIR
:dir
:FILES
:files
dir %2 %3 %4 /p
echo 
echo It's quicker to use the equivalent DOS command sentence:
echo             [01mDIR %2 %3 %4[00m
echo Consult your DOS manual (or SHOW COMMANDS) for more details
showexit


:MENU
:menu
:HELP
:help
cls
echo The SHOW command can be used to display the following information:
echo 
echo     SHOW FILES (show a list of files)
echo     SHOW FILE (type out a specific file on the screen)
echo     SHOW COMMANDS (type out a partial list of selected DOS commands)
echo     SHOW HERE (indicate what disk and directory you're using)
echo     SHOW SPACE (show space available on disk and in memory)
echo 
echo Consult your DOS manual (or SHOW COMMANDS) for more details
showexit

REM Next lines check for file existence and do a TYPE with MORE
:FILE
:file
cls 
if not %2x==x goto LIST0
echo 
echo Can't run SHOW FILE "naked," because the SHOW FILE command
echo requires that you specify which file to show.
echo 
echo Try again, but this time type SHOW FILE "filespec",
echo where "filespec" represents the name of the file you want to show.
showexit
:LIST0
:list0
SHIFT
if exist %1 goto LIST1
echo The file %1 doesn't seem to exist in the directory which you specified
echo (or in the current directory if you didn't specify a directory).
echo 
echo You'll need to find the file %1 to be able to TYPE it.  Try to find it 
echo using the DOS "DIR" command  (the same as the PIDGIN command SHOW FILES) 
echo to explore other directories and disk drives.  
echo 
echo Consult your DOS manual (or SHOW COMMANDS) for more details
showexit
:LIST1
:list1
echo 
echo Ready to type out the file %1 on the screen.  
echo If you see the word --More-- echo at the bottom of the screen, 
echo press the space bar to continue the display.
echo 
pause
type %1 | more
echo 
echo A quicker way is to use the DOS command [01mTYPE[00m by typing:
echo TYPE %1, or to use a listing program such as LIST.COM
echo 
echo For a screen-displayed list of files, use the DOS command DIR, 
echo or type SHOW FILES.
echo 
echo Consult your DOS manual (or SHOW COMMANDS) for more details
showexit

REM These next lines do a CHKDSK if that program is in the path
:SPACE
:space
:CHKDSK
:chkdsk
echo Thanks for waiting . . . .
if exist chkdsk.com goto CHKDSK1
cls
echo Can't find the program file CHKDSK.COM, which is required for this command.
echo
showexit
:CHKDSK1
:chkdsk1
cls
echo Now executing the DOS command sentence [01mCHKDSK %2[00m
chkdsk %2
echo 
echo 
echo You typed:  [01m%0 %1 %2[00m
echo 
echo It's quicker to just type CHKDSK, followed by the letter of 
echo the disk drive that you want to examine, e.g., CHKDSK A: or CHKDSK C:
echo 
echo Consult your DOS manual (or SHOW COMMANDS) for more details
showexit

REM Next lines do a CD to show the user where he or she is
:WHERE
:where
:HERE
:here
echo 
echo The disk ("file drawer") and directory ("file folder") currently open are:
echo -------------------
cd
echo -------------------
echo 
echo Your "prompt" (see the DOS manual) may also be set up to tell you 
echo where you are
echo 
echo Use the DOS command "CD" [for C)hange D)irectory] 
echo to switch to another directory on the same disk
echo 
echo To switch to a different disk, type the letter of the disk
echo immediately followed by a colon (e.g., A: or B: or C: etc.)
echo 
echo Consult your DOS manual (or SHOW COMMANDS) for more details
showexit

REM Here's the list of DOS commands
:CMD
:cmd
:COMMANDS
:commands
:COMMAND
:command
:DOS
:dos
cls
echo 
echo Partial list of DOS commands (see your DOS manual for more details):
echo 
echo BACKUP     Back up files to floppy disk
echo CD         Change directory (to change disk, type A:, C:, etc.)
echo CLS        Clear the screen
echo COMP       Compare two files
echo COPY       Copy one or more files from one place to another
echo DATE       Set the date on the computer's system clock
echo DEL        Delete one or more files
echo DIR        Show a DIRectory listing, i.e., a list of files in a directory
echo DISKCOMP   Compare two disks
echo DISKCOPY   Do a byte-for-byte copy of one disk to another
echo ERASE      Same as DEL
echo FORMAT     Prepare a disk for use with DOS (WARNING:  FORMAT destroys data)
echo MD         Make a new directory
echo PATH       Specify the directories in which DOS looks for files when told to
echo PRINT      Printing program supplied with DOS
echo PROMPT     Set the cursor prompt (e.g., "C:>")
echo RECOVER    Recover files from BACKUP disks
echo RENAME     Change the name of a file from one name to another
echo TIME       Set the time of the computer's system clock
echo TYPE       Type a file to the screen (but LIST.COM works better)
echo 
showexit

REM Very basic error handler
:GOOF
:goof
cls
echo The command sentence you typed:
echo 
echo                         [01m%0 %1 %2 %3 %4 %5 %6 %7[00m
echo 
echo wasn't understood.  Type SHOW MENU for a list of SHOW commands
showexit

:END
:end
@Echo on
